/* (C) 1998 Red Hat Software, Inc. -- Licensing details are in the COPYING
   file accompanying popt source distributions, available from 
   ftp://ftp.redhat.com/pub/code/popt */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifdef __NeXT
/* access macros are not declared in non posix mode in unistd.h -
 don't try to use posix on NeXTstep 3.3 ! */ 
#include <libc.h>
#endif

#if HAVE_ALLOCA_H
# include <alloca.h>
#endif

#if defined(_WIN32) && defined(_MSC_VER)
#include <io.h>
#endif

#include "findme.h"

char * findProgramPath(char * argv0) {
    char * path = getenv("PATH");
    char * pathbuf;
    char * start, * chptr;
    char * buf;

    /* If there is a / in the argv[0], it has to be an absolute
       path */
#if defined(_WIN32) && defined(_MSC_VER)
	if (strchr(argv0, '\\') && strchr(argv0,':'))
#else
	if (strchr(argv0, '/'))
#endif
	return strdup(argv0);

    if (!path) return NULL;

#if defined(_WIN32) && defined(_MSC_VER)
    start = pathbuf = (char *)_alloca(strlen(path) + 1);
#else
    start = pathbuf = (char *)alloca(strlen(path) + 1);
#endif
    buf = malloc(strlen(path) + strlen(argv0) + 2);
    strcpy(pathbuf, path);

    chptr = NULL;
    do {
#if defined(_WIN32) && defined(_MSC_VER)
	if ((chptr = strchr(start, ';')))
	    *chptr = '\0';
	sprintf(buf, "%s\\%s", start, argv0);
	if (!_access(buf, 04))	// check read permission
	    return buf;
#else
	if ((chptr = strchr(start, ':')))
	    *chptr = '\0';
	sprintf(buf, "%s/%s", start, argv0);
	if (!access(buf, X_OK))	// check Execute permission
	    return buf;
#endif


	if (chptr) 
	    start = chptr + 1;
	else
	    start = NULL;
    } while (start && *start);

    free(buf);

    return NULL;
}
